#!/usr/bin/env python

'''
sjRpc client example.
'''

from __future__ import absolute_import

import sys
import threading
import logging
import time
import fcntl
import os
import tty

from sjrpc.core import RpcConnection
from sjrpc.core.protocols import TunnelProtocol


#logger = logging.getLogger()
#logger.setLevel(logging.DEBUG)
#fmt = logging.Formatter('%(levelname)s %(name)s %(message)s')
#handler = logging.StreamHandler()
#handler.setFormatter(fmt)
#logger.addHandler(handler)

def iperf(socket):
    f = open('/dev/null', 'w')
    while True:
        read = socket.recv(1024 * 64)
        f.write(read)


class _FakeStdio(object):

    '''
    A fake standard io to make stdin/stdout look like a socket.
    '''

    def __init__(self):
        tty.setraw(sys.stdin.fileno())

    def recv(self, size):
        return sys.stdin.read(size)

    def send(self, data):
        sys.stdout.write(data)
        sys.stdout.flush()
        return len(data)

    def fileno(self):
        return sys.stdin.fileno()

    def setblocking(self, blocking):
        if not blocking:
            # Disable blocking mode on stdin:
            current_flags = fcntl.fcntl(sys.stdin, fcntl.F_GETFL)
            fcntl.fcntl(sys.stdin, fcntl.F_SETFL, current_flags | os.O_NONBLOCK)
        else:
            raise NotImplementedError('Not implemented')

# Get arguments from the command line:
if len(sys.argv) < 3:
    print 'Usage: %s <listening address> <listening port>' % sys.argv[0]
    sys.exit(2)
address = sys.argv[1]
port = int(sys.argv[2])

# Create the rpc connection:
conn = RpcConnection.from_addr(address, port)

print 'connected.'

# Run the connection mainloop in another thread:
threading.Thread(target=conn.run).start()
time.sleep(0.1)

# Create the tunnel on the remote server:
label = conn.call('launch_remote_console')

# Create a fake socket object wrapping stdin and stdout:
fake_stdio = _FakeStdio()

# Create the tunnel on the local side:
conn.register_protocol(label, TunnelProtocol, endpoint=fake_stdio)

#label = conn.call('iperf')
#tun = conn.register_protocol(label, TunnelProtocol)
#t = threading.Thread(target=iperf, args=(tun._socket,))
#t.daemon = True
#t.start()

#f = open('/dev/null', 'w')
#while True:
#    read = tun._socket.recv(1024 * 64)
#    f.write(read)

# Start the shell

rcode = conn.call('wait_for_pshell', _timeout=None)
print '\nremote process returned with code %s\n' % rcode

conn.shutdown()

